#!/bin/sh

VARJAVAMAXHEAPSIZE=1000M
VARMEDIACACHE_MAXPENDINGWRITEREQUESTSIZE=150000000
VARMEDIACACHE_MAXPENDINGREADAHEADREQUESTSIZE=75000000
VARMEDIACACHE_STOREMAXSIZE=100000000000

# memory/disk

if [ ${AWSEC2_METADATA_INSTANCE_TYPE} = "m1.small" ]; then
# 154068/153899044
VARJAVAMAXHEAPSIZE=1000M
VARMEDIACACHE_MAXPENDINGWRITEREQUESTSIZE=150000000
VARMEDIACACHE_MAXPENDINGREADAHEADREQUESTSIZE=75000000
VARMEDIACACHE_STOREMAXSIZE=100000000000
elif [ ${AWSEC2_METADATA_INSTANCE_TYPE} = "m1.medium" ]; then
# 3844852k/412814512
VARJAVAMAXHEAPSIZE=2800M
VARMEDIACACHE_MAXPENDINGWRITEREQUESTSIZE=300000000
VARMEDIACACHE_MAXPENDINGREADAHEADREQUESTSIZE=150000000
VARMEDIACACHE_STOREMAXSIZE=300000000000
elif [ ${AWSEC2_METADATA_INSTANCE_TYPE} = "m1.large" ]; then
# 7652592/433455904
VARJAVAMAXHEAPSIZE=5000M
VARMEDIACACHE_MAXPENDINGWRITEREQUESTSIZE=600000000
VARMEDIACACHE_MAXPENDINGREADAHEADREQUESTSIZE=400000000
VARMEDIACACHE_STOREMAXSIZE=300000000000
elif [ ${AWSEC2_METADATA_INSTANCE_TYPE} = "m1.xlarge" ]; then
# 15378216/433455904
VARJAVAMAXHEAPSIZE=8000M
VARMEDIACACHE_MAXPENDINGWRITEREQUESTSIZE=800000000
VARMEDIACACHE_MAXPENDINGREADAHEADREQUESTSIZE=500000000
VARMEDIACACHE_STOREMAXSIZE=300000000000
elif [ ${AWSEC2_METADATA_INSTANCE_TYPE} = "m3.xlarge" ]; then
# 17530704/???????
VARJAVAMAXHEAPSIZE=8000M
VARMEDIACACHE_MAXPENDINGWRITEREQUESTSIZE=1000000000
VARMEDIACACHE_MAXPENDINGREADAHEADREQUESTSIZE=600000000
VARMEDIACACHE_STOREMAXSIZE=5000000000
elif [ ${AWSEC2_METADATA_INSTANCE_TYPE} = "m3.2xlarge" ]; then
# 35134420/???????
VARJAVAMAXHEAPSIZE=8000M
VARMEDIACACHE_MAXPENDINGWRITEREQUESTSIZE=1000000000
VARMEDIACACHE_MAXPENDINGREADAHEADREQUESTSIZE=600000000
VARMEDIACACHE_STOREMAXSIZE=5000000000
elif [ ${AWSEC2_METADATA_INSTANCE_TYPE} = "t1.micro" ]; then
# 613M/???
VARJAVAMAXHEAPSIZE=300M
VARMEDIACACHE_MAXPENDINGWRITEREQUESTSIZE=20000000
VARMEDIACACHE_MAXPENDINGREADAHEADREQUESTSIZE=10000000
VARMEDIACACHE_STOREMAXSIZE=100000000000
elif [ ${AWSEC2_METADATA_INSTANCE_TYPE} = "m2.xlarge" ]; then
# 17530704/418579200
VARJAVAMAXHEAPSIZE=8000M
VARMEDIACACHE_MAXPENDINGWRITEREQUESTSIZE=1000000000
VARMEDIACACHE_MAXPENDINGREADAHEADREQUESTSIZE=600000000
VARMEDIACACHE_STOREMAXSIZE=300000000000
elif [ ${AWSEC2_METADATA_INSTANCE_TYPE} = "m2.2xlarge" ]; then
# 35134420/866917368
VARJAVAMAXHEAPSIZE=8000M
VARMEDIACACHE_MAXPENDINGWRITEREQUESTSIZE=1000000000
VARMEDIACACHE_MAXPENDINGREADAHEADREQUESTSIZE=600000000
VARMEDIACACHE_STOREMAXSIZE=500000000000
elif [ ${AWSEC2_METADATA_INSTANCE_TYPE} = "m2.4xlarge" ]; then
# 70343656/866917368
VARJAVAMAXHEAPSIZE=8000M
VARMEDIACACHE_MAXPENDINGWRITEREQUESTSIZE=1000000000
VARMEDIACACHE_MAXPENDINGREADAHEADREQUESTSIZE=600000000
VARMEDIACACHE_STOREMAXSIZE=500000000000
elif [ ${AWSEC2_METADATA_INSTANCE_TYPE} = "c1.medium" ]; then
# 1758616/350891748
VARJAVAMAXHEAPSIZE=1000M
VARMEDIACACHE_MAXPENDINGWRITEREQUESTSIZE=150000000
VARMEDIACACHE_MAXPENDINGREADAHEADREQUESTSIZE=75000000
VARMEDIACACHE_STOREMAXSIZE=200000000000
elif [ ${AWSEC2_METADATA_INSTANCE_TYPE} = "c1.xlarge" ]; then
# 7136868/433455904
VARJAVAMAXHEAPSIZE=5000M
VARMEDIACACHE_MAXPENDINGWRITEREQUESTSIZE=600000000
VARMEDIACACHE_MAXPENDINGREADAHEADREQUESTSIZE=400000000
VARMEDIACACHE_STOREMAXSIZE=300000000000
elif [ ${AWSEC2_METADATA_INSTANCE_TYPE} = "cc1.4xlarge" ]; then
# 23G/433455904
VARJAVAMAXHEAPSIZE=8000M
VARMEDIACACHE_MAXPENDINGWRITEREQUESTSIZE=1000000000
VARMEDIACACHE_MAXPENDINGREADAHEADREQUESTSIZE=600000000
VARMEDIACACHE_STOREMAXSIZE=300000000000
elif [ ${AWSEC2_METADATA_INSTANCE_TYPE} = "cc2.8xlarge" ]; then
# 60.5G/433455904
VARJAVAMAXHEAPSIZE=8000M
VARMEDIACACHE_MAXPENDINGWRITEREQUESTSIZE=1000000000
VARMEDIACACHE_MAXPENDINGREADAHEADREQUESTSIZE=600000000
VARMEDIACACHE_STOREMAXSIZE=300000000000
elif [ ${AWSEC2_METADATA_INSTANCE_TYPE} = "cg1.4xlarge" ]; then
# 22G/433455904
VARJAVAMAXHEAPSIZE=8000M
VARMEDIACACHE_MAXPENDINGWRITEREQUESTSIZE=1000000000
VARMEDIACACHE_MAXPENDINGREADAHEADREQUESTSIZE=600000000
VARMEDIACACHE_STOREMAXSIZE=300000000000
elif [ ${AWSEC2_METADATA_INSTANCE_TYPE} = "hi1.4xlarge" ]; then
# 16G/31084032
VARJAVAMAXHEAPSIZE=8000M
VARMEDIACACHE_MAXPENDINGWRITEREQUESTSIZE=1000000000
VARMEDIACACHE_MAXPENDINGREADAHEADREQUESTSIZE=600000000
VARMEDIACACHE_STOREMAXSIZE=10000000000
elif [ ${AWSEC2_METADATA_INSTANCE_TYPE} = "hs1.8xlarge" ]; then
# 117G/60198904
VARJAVAMAXHEAPSIZE=8000M
VARMEDIACACHE_MAXPENDINGWRITEREQUESTSIZE=1000000000
VARMEDIACACHE_MAXPENDINGREADAHEADREQUESTSIZE=600000000
VARMEDIACACHE_STOREMAXSIZE=10000000000
fi
export VARJAVAMAXHEAPSIZE
export VARMEDIACACHE_MAXPENDINGWRITEREQUESTSIZE
export VARMEDIACACHE_MAXPENDINGREADAHEADREQUESTSIZE
export VARMEDIACACHE_STOREMAXSIZE

echo "Tuning Wowza Media Server: ${AWSEC2_METADATA_INSTANCE_TYPE}"
echo "Java Heap Size: ${VARJAVAMAXHEAPSIZE}"
echo "MediaCache: MaxPendingWriteRequestSize: ${VARMEDIACACHE_MAXPENDINGWRITEREQUESTSIZE}"
echo "MediaCache: MaxPendingReadAheadRequestSize: ${VARMEDIACACHE_MAXPENDINGREADAHEADREQUESTSIZE}"
echo "MediaCache: MediaCacheStore/MaxSize: ${VARMEDIACACHE_STOREMAXSIZE}"

WMSAPP_HOME=/usr/local/WowzaMediaServer
cp ${WMSAPP_HOME}/bin/setenv.sh ${WMSAPP_HOME}/bin/setenv-save.sh
sed "s/{JAVAMAXHEAPSIZE}/${VARJAVAMAXHEAPSIZE}/" "tuning/setenv.sh" > ${WMSAPP_HOME}/bin/setenv.sh
cp ${WMSAPP_HOME}/conf/MediaCache.xml ${WMSAPP_HOME}/bin/MediaCache-save.xml
sed "s/{MEDIACACHE_MAXPENDINGWRITEREQUESTSIZE}/${VARMEDIACACHE_MAXPENDINGWRITEREQUESTSIZE}/;s/{MEDIACACHE_MAXPENDINGREADAHEADREQUESTSIZE}/${VARMEDIACACHE_MAXPENDINGREADAHEADREQUESTSIZE}/;s/{MEDIACACHE_STOREMAXSIZE}/${VARMEDIACACHE_STOREMAXSIZE}/" "tuning/MediaCache.xml" > ${WMSAPP_HOME}/conf/MediaCache.xml
